from H_9U.mao.impl import mvr
from H_9U.util.cache import cacher
from H_9U.models.cachekey import CacheKey, CacheDuration


class MvrApi:

    def read_list(self, device_id):
        return mvr.mvr_list_read(device_id)

    def read_detail(self, device_id, mvr_id):
        return mvr.mvr_full_detail_read(device_id, mvr_id)

    def write_enable(self, device_id, enable):
        return mvr.mvr_enable_write(device_id, enable)

    def read_enable(self, device_id):
        return mvr.mvr_enable_read(device_id)

    def read_general(self, device_id, mvr_id):
        return mvr.mvr_general_read(device_id, mvr_id)

    def write_general(self, device_id, mvr_id, data):
        return mvr.mvr_general_write(device_id, mvr_id, data)

    def write_background_color(self, device_id, mvr_id, data):
        return mvr.mvr_background_color_write(device_id, mvr_id, data)

    def read_background_color_read(self, device_id, mvr_id):
        return mvr.mvr_background_color_read(device_id, mvr_id)


mvr_api = MvrApi()