"""
Created on 2021年9月14日
@author: 程声清
layer服务类
"""
from H_9U.middle import open_screen_middle, open_layer_middle, open_input_middle, open_device_middle
from H_9U.models.sysconst import LayerType, SourceType, ConnectCapacity
from H_9U.models.result import get_result_model, ResInfo


def layer_screen_no_time_play(device_id, screen_id, params):
    """
    屏幕非实时上屏take
    :param device_id: 设备Id
    :param screen_id: 屏幕Id
    :param params: 图层信息
    :return: 结果对象
    """
    # layers = params.get('layers', None)
    # no_time = params.get('enNonTime', 0)
    rs = open_screen_middle.screen_no_time_play_middle(
        device_id, screen_id, params)
    # if rs['status'] == 0:
    #     open_layer_middle.layer_delete_lock_by_screen_middle(
    #         device_id, screen_id)
    #     if layers:
    #         for layer in layers:
    #             layer_id = layer['layerId']
    #             if layer_id is not None:
    #                 if no_time == 1:
    #                     open_layer_middle.layer_write_lock_middle(
    #                         device_id, screen_id, layer_id, 1, 1)
    #                 else:
    #                     open_layer_middle.layer_write_lock_middle(
    #                         device_id, screen_id, layer_id, 0, 1)
    #                     open_layer_middle.layer_write_lock_middle(
    #                         device_id, screen_id, layer_id, 1, 0)
    return rs


def layer_create(device_id, screen_id, params):
    """
    创建图层
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :param params: 中间件协议文档LayerCreate
    :return: {'id':0, 'layersZOrder':[xxx]}
    """
    input_id = params['source']['inputId']
    # 图层类型
    params['general']['type'] = LayerType.Default
    # 初始化一个int变量
    conn = int()
    if params['source']['sourceType'] == SourceType.InputSource:
        rs = open_input_middle.read_detail_middle(device_id, input_id)
        if rs['status'] == 0 and rs['data']:
            rs['data'] = {'connectCapacity': rs['data']
                          ['general']['connectCapacity']}
        # 获取不到连接容量，直接返回错误
        if rs['status'] != 0:
            return get_result_model(ResInfo.Middle_Data_Err)
        conn = rs['data']['connectCapacity']
    elif params['source']['sourceType'] == SourceType.IPCSource:
        mode_rs = open_device_middle.device_ipc_mode_read_middle(device_id)
        if mode_rs['data']['ipcMode'] == 0:
            conn = ConnectCapacity.SL
        else:
            conn = ConnectCapacity.DL
    params['general']['sizeType'] = conn
    # 获取当前屏幕的详细信息
    # screen_detail = open_screen_middle.screen_read_detail_middle(
    #     device_id, screen_id)
    # # if screen_detail['data']:
    # #     interfaces_list = screen_detail['data']['outputMode']['screenInterfaces']
    #     # x, y, h, w = assembly_data(interfaces_list, params)
    #     # params['window']['x'] = x
    #     # params['window']['y'] = y
    #     # params['window']['height'] = h
    #     # params['window']['width'] = w
    rs = open_layer_middle.layer_write_create_middle(
        device_id, screen_id, params)
    if rs['status'] == 0 and rs['data']:
        from H_9U.service import open_screen_svc
        non_time = _screen_non_time(device_id, screen_id)
        if non_time == 0:
            details = open_screen_svc._screen_layer_detail_list(
                device_id, screen_id)
            rs['data']['layers'] = []
            if details['status'] == 0 and rs['data']:
                # 补充图层详细信息
                rs['data']['layers'] = details['data']
        elif non_time == 1:
            details = open_screen_svc.screen_non_time_detail(
                device_id, screen_id)
            if details['status'] == 0:
                rs['data']['layers'] = details['data']['layers']
    return rs


def _screen_non_time(device_id, screen_id):
    """
    屏幕非实时nonTime
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :return: 结果对象
    """
    from H_9U.service import open_screen_svc  # TODO 还需要优化拆分
    rs = open_screen_svc.screen_read_detail(device_id, screen_id)
    if rs['status'] == 0:
        return rs['data']['nonTime']


def layer_delete(device_id, screen_id, layer_id):
    """
    删除图层
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :param layer_id: 图层号
    :return: 结果对象
    """
    non_time = _screen_non_time(device_id, screen_id)
    if non_time is None:
        return get_result_model(ResInfo.Middle_Data_Err)
    else:

        data = {
            "screenId": screen_id,
            "deviceId": device_id,
            "layerId": layer_id
        }
        rs = open_layer_middle.layer_write_delete_middle(
            device_id, screen_id, layer_id, data)
        # if rs['status'] == 0:
        #     open_layer_middle.layer_write_lock_middle(
        #         device_id, screen_id, layer_id, 0, non_time)
    return rs


def layer_read_detail(device_id, screen_id, layer_id):
    """
    读取屏幕详细信息
    :param device_id: 设备Id
    :param screen_id: 屏幕Id
    :param layer_id: 图层Id
    :return: 参考readDetail文档
    """
    # from H_9U.service import open_screen_svc
    # rs = open_screen_svc.screen_layer_detail_list(device_id, screen_id)
    # if rs['status'] == 0 and rs['data']:
    #     rs['data'] = rs['data']['screenLayers']
    #     detail = [x for x in rs['data'] if x['layerId'] == layer_id]
    #     if detail:
    #         rs['data'] = detail[0]
    #     else:
    #         rs['data'] = {}
    rs = open_layer_middle.layer_read_detail_middle(
        device_id, screen_id, layer_id)
    return rs


def layer_write_general(device_id, screen_id, layer_id, data):
    """
    读取图层基本信息
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :param layer_id: 图层号
    :param data: 参考中间件接口协议
    :return: 标准返回
    """
    return open_layer_middle.layer_general_write_middle(
        device_id, screen_id, layer_id, data)


def layer_read_z_index(device_id, screen_id):
    """
      设置图层source 信息
      :param device_id: 设备Id
      :param screen_id: 屏幕id
      :return: 参考中间件协议
      """
    return open_layer_middle.layer_read_z_index_middle(device_id, screen_id)


def layer_write_layout_window(device_id, screen_id, layer_id, data):
    """
     设置图层窗口信息
     :param device_id: 设备Id
     :param screen_id: 屏幕id
     :param layer_id: 图层号
     :param data: 参考中间件接口协议
     :return: 标准返回
     """
    # 判断图层Id<0返回参数错误
    if layer_id < 0:
        return get_result_model()
    return open_layer_middle.layer_write_layout_window_middle(
        device_id, screen_id, layer_id, data)


def layer_clear(device_id, screen_id):
    """
    清空屏幕图层
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :return: 结果对象
    """
    rs = open_screen_middle.screen_clear_layers_middle(device_id, screen_id)
    # if rs['status'] == 0:
    #     open_layer_middle.layer_delete_lock_by_screen_middle(
    #         device_id, screen_id)
    return rs


def layer_write_z_index(device_id, screen_id, data):
    """
    设置图层Z序
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :param data: 参考中间件接口协议
    :return: 参考中间件协议
    """
    return open_layer_middle.layer_write_z_index_middle(
        device_id, screen_id, data)


def layer_write_z_lock(device_id, screen_id, layer_id, is_lock):
    """
    设置图层锁定
    :param device_id: 设备Id
    :param screen_id: 屏幕Id
    :param layer_id: 图层Id
    :param is_lock: 是否锁定
    :return:
    """
    non_time = _screen_non_time(device_id, screen_id)
    if non_time is not None:
        rs = open_layer_middle.layer_write_lock_middle(
            device_id, screen_id, layer_id, is_lock)
    else:
        rs = get_result_model(ResInfo.Middle_Data_Err)
    return rs


def layer_write_source(device_id, screen_id, layer_id, data):
    """
    设置图层source 信息
    :param device_id: 设备Id
    :param screen_id: 屏幕id
    :param layer_id: 图层号
    :param data: 参考中间件接口协议
    :return: 标准返回
    """
    return open_layer_middle.layer_write_source_middle(
        device_id, screen_id, layer_id, data)


def layer_freeze(device_id, screen_id, layer_id, data):
    """
    屏幕图层上屏
    :param device_id: 设备Id
    :param screen_id: 屏幕Id
    :param layer_id: 图层id
    :param data:
    :return: 结果对象
    """
    return open_layer_middle.layer_freeze_middle(
        device_id, screen_id, layer_id, data)


def screen_layer_layout(device_id, screen_id, data):
    """
    屏幕图层自动布局（模板开窗）
    :param device_id: 设备Id
    :param screen_id: 屏幕Id
    :param data: 图层数据
    :return: 结果对象
    """
    layers = data.get('layers', None)
    if layers is None:
        return get_result_model(ResInfo.Params_Error)
    return open_layer_middle.write_screen_layer_layout_middle(
        device_id, screen_id, data)
